import streamlit as st
import requests
import json

def func(info):
    data = """
    序号,歌名,关系,人名
    0,平凡天使,歌手,邓紫棋
    1,平凡天使,作词,邓紫棋
    2,平凡天使,作曲,邓紫棋
    3,摩天动物园,歌手,邓紫棋
    4,摩天动物园,作词,邓紫棋
    5,摩天动物园,作曲,邓紫棋
    6,很久以后,歌手,邓紫棋
    7,很久以后,作词,邓紫棋
    8,很久以后,作曲,邓紫棋
    9,差不多姑娘,歌手,邓紫棋
    10,差不多姑娘,作词,邓紫棋
    11,差不多姑娘,作曲,邓紫棋
    12,别勉强,歌手,"邓紫棋, 周兴哲"
    13,别勉强,作词,邓紫棋
    14,别勉强,作曲,邓紫棋
    15,依然睡公主,歌手,邓紫棋
    16,依然睡公主,作词,邓紫棋
    17,依然睡公主,作曲,邓紫棋
    18,《热爱就一起》,歌手,邓紫棋、王嘉尔
    19,《热爱就一起》,作词,邓紫棋、王嘉尔
    20,《热爱就一起》,作曲,Gajaila Alexandru
    21,岩石里的花,歌手,邓紫棋
    22,岩石里的花,作词,邓紫棋
    23,岩石里的花,作曲,邓紫棋
    24,睡皇后,歌手,邓紫棋
    25,睡皇后,作词,未知
    26,睡皇后,作曲,未知
    27,毒苹果,歌手,邓紫棋
    28,毒苹果,作词,未知
    29,毒苹果,作曲,未知
    30,突然之间,歌手,邓紫棋
    31,突然之间,作词,邓紫棋
    32,突然之间,作曲,邓紫棋
    33,错过不错,歌手,邓紫棋
    34,错过不错,作词,邓紫棋
    35,错过不错,作曲,"邓紫棋, Lupo Groinig"
    36,另一个童话,歌手,邓紫棋
    37,另一个童话,作词,未知
    38,另一个童话,作曲,未知
    39,爱如意,歌手,邓紫棋
    40,爱如意,作词,程诗迦
    41,爱如意,作曲,陈雪燃
    42,A.I.N.Y.,歌手,邓紫棋
    43,A.I.N.Y.,作词,邓紫棋
    44,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    45,心之焰,歌手,邓紫棋
    46,心之焰,作词,"林乔,张赢"
    47,心之焰,作曲,罗锟
    48,光年之外,歌手,邓紫棋
    49,光年之外,作词,邓紫棋
    50,光年之外,作曲,邓紫棋
    51,死了都要 • 爱,歌手,邓紫棋
    52,死了都要 • 爱,作词,"邓紫棋, 姚若龙"
    53,死了都要 • 爱,作曲,"邓紫棋, Lupo Groinig, Yoo Hae Jin"
    54,红蔷薇白玫瑰,歌手,邓紫棋
    55,红蔷薇白玫瑰,作词,邓紫棋
    56,红蔷薇白玫瑰,作曲,"TE DI, SOL"
    57,多远都要在一起,歌手,邓紫棋
    58,多远都要在一起,作词,邓紫棋
    59,多远都要在一起,作曲,邓紫棋
    60,新的心跳,歌手,邓紫棋
    61,新的心跳,作词,未知
    62,新的心跳,作曲,未知
    63,来自天堂的魔鬼,歌手,邓紫棋
    64,来自天堂的魔鬼,作词,邓紫棋
    65,来自天堂的魔鬼,作曲,邓紫棋
    66,单行的轨道,歌手,邓紫棋
    67,单行的轨道,作词,邓紫棋
    68,单行的轨道,作曲,邓紫棋
    69,一路逆风,歌手,邓紫棋
    70,一路逆风,作词,Nick Wickham
    71,一路逆风,作曲,Nick Wickham
    72,查克靠近,歌手,邓紫棋
    73,查克靠近,作词,邓紫棋
    74,查克靠近,作曲,邓紫棋
    75,NULL,歌手,邓紫棋（G.E.M.）
    76,NULL,作词,NULL
    77,NULL,作曲,NULL
    78,A.I.N.Y.,歌手,邓紫棋
    79,A.I.N.Y.,作词,邓紫棋
    80,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    81,Someday I'll Fly,歌手,邓紫棋
    82,Someday I'll Fly,作词,邓紫棋
    83,Someday I'll Fly,作曲,"Franzel Jeffrey B, Hollander Andrew B, Dana Parish"
    84,All About U,歌手,邓紫棋
    85,All About U,作词,邓紫棋
    86,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    87,回忆的沙漏,歌手,邓紫棋
    88,回忆的沙漏,作词,庭竹
    89,回忆的沙漏,作曲,邓紫棋
    90,NULL,歌手,邓紫棋（G.E.M.）
    91,NULL,作词,NULL
    92,NULL,作曲,NULL
    93,Where Did U Go,歌手,邓紫棋
    94,Where Did U Go,作词,邓紫棋
    95,Where Did U Go,作曲,Skot Suyama
    96,Good To Be Bad,歌手,邓紫棋
    97,Good To Be Bad,作词,邓紫棋
    98,Good To Be Bad,作曲,Peter Roberts
    99,What Have U Done,歌手,邓紫棋
    100,What Have U Done,作词,邓紫棋
    101,What Have U Done,作曲,"Johnny Pederson, Michael Jay, Rike Boomgaarden"
    102,想讲你知,歌手,邓紫棋
    103,想讲你知,作词,邓紫棋
    104,想讲你知,作曲,"Sidh Solanki, Marc Nelkin, Jennifer Karr"
    105,Twinkle II,歌手,邓紫棋
    106,Twinkle II,作词,邓紫棋
    107,Twinkle II,作曲,邓紫棋
    108,Oh Boy,歌手,邓紫棋
    109,Oh Boy,作词,邓紫棋
    110,Oh Boy,作曲,"Lupo Groinig, 邓紫棋"
    111,A.I.N.Y.,歌手,邓紫棋
    112,A.I.N.Y.,作词,邓紫棋
    113,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    114,Someday I'll Fly,歌手,邓紫棋
    115,Someday I'll Fly,作词,邓紫棋
    116,Someday I'll Fly,作曲,"Franzel Jeffrey B, Hollander Andrew B, Dana Parish"
    117,All About U,歌手,邓紫棋
    118,All About U,作词,邓紫棋
    119,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    120,Where Did U Go,歌手,邓紫棋
    121,Where Did U Go,作词,邓紫棋
    122,Where Did U Go,作曲,Skot Suyama
    123,Good To Be Bad,歌手,邓紫棋
    124,Good To Be Bad,作词,邓紫棋
    125,Good To Be Bad,作曲,Peter Roberts
    126,What Have U Done,歌手,邓紫棋
    127,What Have U Done,作词,邓紫棋
    128,What Have U Done,作曲,"Johnny Pederson, Michael Jay, Rike Boomgaarden"
    129,Oh Boy,歌手,邓紫棋
    130,Oh Boy,作词,邓紫棋
    131,Oh Boy,作曲,"Lupo Groinig, 邓紫棋"
    132,Twinkle II,歌手,邓紫棋
    133,Twinkle II,作词,邓紫棋
    134,Twinkle II,作曲,邓紫棋
    135,What Have U Done,歌手,邓紫棋
    136,What Have U Done,作词,邓紫棋
    137,What Have U Done,作曲,"Johnny Pederson, Michael Jay, Rike Boomgaarden"
    138,Someday I'll Fly,歌手,邓紫棋
    139,Someday I'll Fly,作词,邓紫棋
    140,Someday I'll Fly,作曲,"Franzel Jeffrey B, Hollander Andrew B, Dana Parish"
    141,潜意式的残酷,歌手,邓紫棋
    142,潜意式的残酷,作词,邓紫棋
    143,潜意式的残酷,作曲,"邓紫棋, Lupo Groinig"
    144,Oh Boy,歌手,邓紫棋
    145,Oh Boy,作词,邓紫棋
    146,Oh Boy,作曲,"Lupo Groinig, 邓紫棋"
    147,After Tonight,歌手,邓紫棋
    148,After Tonight,作词,邓紫棋
    149,After Tonight,作曲,"邓紫棋, Lupo Groinig"
    150,不存在的存在,歌手,邓紫棋
    151,不存在的存在,作词,邓紫棋
    152,不存在的存在,作曲,邓紫棋
    153,想讲你知,歌手,邓紫棋
    154,想讲你知,作词,邓紫棋
    155,想讲你知,作曲,"Sidh Solanki, Marc Nelkin, Jennifer Karr"
    156,我不懂爱,歌手,邓紫棋
    157,我不懂爱,作词,邓紫棋
    158,我不懂爱,作曲,Peter Roberts
    159,等一个他,歌手,邓紫棋
    160,等一个他,作词,邓紫棋
    161,等一个他,作曲,"Tommy Tysper, Marcus Sepehrmanesh"
    162,我的秘密,歌手,邓紫棋
    163,我的秘密,作词,邓紫棋
    164,我的秘密,作曲,邓紫棋
    165,All About U,歌手,邓紫棋
    166,All About U,作词,邓紫棋
    167,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    168,Good To Be Bad,歌手,邓紫棋
    169,Good To Be Bad,作词,邓紫棋
    170,Good To Be Bad,作曲,Peter Roberts
    171,寂寞星球的玫瑰,歌手,邓紫棋
    172,寂寞星球的玫瑰,作词,邓紫棋
    173,寂寞星球的玫瑰,作曲,邓紫棋
    174,A.I.N.Y.,歌手,邓紫棋
    175,A.I.N.Y.,作词,邓紫棋
    176,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    177,Twinkle II,歌手,邓紫棋
    178,Twinkle II,作词,邓紫棋
    179,Twinkle II,作曲,邓紫棋
    180,One Button,歌手,邓紫棋
    181,One Button,作词,邓紫棋
    182,One Button,作曲,"Mads Haugaard, Jade Ell"
    183,NULL,歌手,邓紫棋（G.E.M.）
    184,NULL,作词,NULL
    185,NULL,作曲,NULL
    186,《G.E.M.》,歌手,邓紫棋
    187,《G.E.M.》,作词,邓紫棋
    188,《G.E.M.》,作曲,Lupo Groinig
    189,Where Did U Go,歌手,邓紫棋
    190,Where Did U Go,作词,邓紫棋
    191,Where Did U Go,作曲,Skot Suyama
    192,A.I.N.Y.,歌手,邓紫棋
    193,A.I.N.Y.,作词,邓紫棋
    194,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    195,One Button,歌手,邓紫棋
    196,One Button,作词,邓紫棋
    197,One Button,作曲,"Mads Haugaard, Jade Ell"
    198,Good To Be Bad,歌手,邓紫棋
    199,Good To Be Bad,作词,邓紫棋
    200,Good To Be Bad,作曲,Peter Roberts
    201,Where Did U Go,歌手,邓紫棋
    202,Where Did U Go,作词,邓紫棋
    203,Where Did U Go,作曲,Skot Suyama
    204,回忆的沙漏,歌手,邓紫棋
    205,回忆的沙漏,作词,庭竹
    206,回忆的沙漏,作曲,邓紫棋
    207,爱现在的我,歌手,邓紫棋
    208,爱现在的我,作词,庭竹、张丹、邓紫棋
    209,爱现在的我,作曲,陶山
    210,All About U,歌手,邓紫棋
    211,All About U,作词,邓紫棋
    212,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    213,想讲你知,歌手,邓紫棋
    214,想讲你知,作词,邓紫棋
    215,想讲你知,作曲,"Sidh Solanki, Marc Nelkin, Jennifer Karr"
    216,我不懂爱,歌手,邓紫棋
    217,我不懂爱,作词,邓紫棋
    218,我不懂爱,作曲,Peter Roberts
    219,寂寞星球的玫瑰,歌手,邓紫棋
    220,寂寞星球的玫瑰,作词,邓紫棋
    221,寂寞星球的玫瑰,作曲,邓紫棋
    222,我的秘密,歌手,邓紫棋
    223,我的秘密,作词,邓紫棋
    224,我的秘密,作曲,邓紫棋
    225,Twinkle II,歌手,邓紫棋
    226,Twinkle II,作词,邓紫棋
    227,Twinkle II,作曲,邓紫棋
    228,Say it Loud,歌手,邓紫棋
    229,Say it Loud,作词,邓紫棋
    230,Say it Loud,作曲,"邓紫棋, Lupo Groinig"
    231,亚莉亚蒂之歌,歌手,邓紫棋
    232,亚莉亚蒂之歌,作词,邓紫棋
    233,亚莉亚蒂之歌,作曲,"Simon Caby, 塞西尔·科贝尔"
    234,One Button,歌手,邓紫棋
    235,One Button,作词,邓紫棋
    236,One Button,作曲,"Mads Haugaard, Jade Ell"
    237,Good To Be Bad,歌手,邓紫棋
    238,Good To Be Bad,作词,邓紫棋
    239,Good To Be Bad,作曲,Peter Roberts
    240,美好的旧时光,歌手,邓紫棋
    241,美好的旧时光,作词,邓紫棋
    242,美好的旧时光,作曲,"邓紫棋, Lupo Groinig"
    243,寂寞星球的玫瑰,歌手,邓紫棋
    244,寂寞星球的玫瑰,作词,邓紫棋
    245,寂寞星球的玫瑰,作曲,邓紫棋
    246,我的秘密,歌手,邓紫棋
    247,我的秘密,作词,邓紫棋
    248,我的秘密,作曲,邓紫棋
    249,Twinkle II,歌手,邓紫棋
    250,Twinkle II,作词,邓紫棋
    251,Twinkle II,作曲,邓紫棋
    252,Say it Loud,歌手,邓紫棋
    253,Say it Loud,作词,邓紫棋
    254,Say it Loud,作曲,"邓紫棋, Lupo Groinig"
    255,Good To Be Bad,歌手,邓紫棋
    256,Good To Be Bad,作词,邓紫棋
    257,Good To Be Bad,作曲,Peter Roberts
    258,我不懂爱,歌手,邓紫棋
    259,我不懂爱,作词,邓紫棋
    260,我不懂爱,作曲,Peter Roberts
    261,爱现在的我,歌手,邓紫棋
    262,爱现在的我,作词,庭竹、张丹、邓紫棋
    263,爱现在的我,作曲,陶山
    264,回忆的沙漏,歌手,邓紫棋
    265,回忆的沙漏,作词,庭竹
    266,回忆的沙漏,作曲,邓紫棋
    267,All About U,歌手,邓紫棋
    268,All About U,作词,邓紫棋
    269,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    270,想讲你知,歌手,邓紫棋
    271,想讲你知,作词,邓紫棋
    272,想讲你知,作曲,"Sidh Solanki, Marc Nelkin, Jennifer Karr"
    273,写不完的温柔,歌手,邓紫棋
    274,写不完的温柔,作词,"邓紫棋,张丹"
    275,写不完的温柔,作曲,陶山
    276,All About U,歌手,邓紫棋
    277,All About U,作词,邓紫棋
    278,All About U,作曲,"Kaci Brown, Marc Nelkin, David Gamson"
    279,想讲你知,歌手,邓紫棋
    280,想讲你知,作词,邓紫棋
    281,想讲你知,作曲,"Sidh Solanki, Marc Nelkin, Jennifer Karr"
    282,A.I.N.Y.,歌手,邓紫棋
    283,A.I.N.Y.,作词,邓紫棋
    284,A.I.N.Y.,作曲,"Lupo Groinig, 邓紫棋"
    285,我不懂爱,歌手,邓紫棋
    286,我不懂爱,作词,邓紫棋
    287,我不懂爱,作曲,Peter Roberts
    288,意式恋爱,歌手,邓紫棋
    289,意式恋爱,作词,夏至
    290,意式恋爱,作曲,Skot Suyama
    291,等一个他,歌手,邓紫棋
    292,等一个他,作词,邓紫棋
    293,等一个他,作曲,"Tommy Tysper, Marcus Sepehrmanesh"
    294,Where Did U Go,歌手,邓紫棋
    295,Where Did U Go,作词,邓紫棋
    296,Where Did U Go,作曲,Skot Suyama
    """
    url = 'http://localhost:11434/api/chat'
    headers = {
        "Content-Type": "application/json"
    }
    data = {
        "model": "qwen2.5_7b",
        "messages": [{"role": "user", "content": f"基于以下结构化数据，建立知识关联以回答问题：每条记录以编号、歌曲名称、属性（如歌手、作词、作曲）和人物信息表示。每首歌可能有不同的关联信息，如歌手、作词人、作曲人，且这些信息可能重复或多次出现。通过结构化信息，能够识别某歌曲的某角色，如“67, 单行的轨道, 作词, 邓紫棋”说明《单行的轨道》的作词人是邓紫棋。你的结构化知识库是{data}。用户的问题是{info}，你需要根据知识库中的内容回答用户的问题"}],
        "stream": False,
        "options": {
            "temperature": 0.3
        }
    }

    response = requests.post(url, headers=headers, data=json.dumps(data)).json()
    # print(type(response['message']['content']))
    print(response)
    if isinstance(response,dict):
        return response['message']['content']
    else:
        return None


# 设置标题
st.title("邓紫棋知识问答")

# 输入框
user_input = st.text_input("请在下面输入你的问题：", "")

# 按钮触发
if st.button("提交"):
    if user_input:
        # 打印问题到控制台
        ans = func(user_input)
        print(f"用户输入的问题是：{user_input}")
        # 在页面上显示确认信息
        st.success(f"{ans}")
    else:
        st.warning("请输入一个问题后再提交！")
